import { type UniversalOptions, type Config } from '@pnpm/config';
import { type ProjectManifest } from '@pnpm/types';
export declare function rcOptionsTypes(): Record<string, unknown>;
export declare function cliOptionsTypes(): Record<string, unknown>;
export declare const commandNames: string[];
export declare function help(): string;
export type PackOptions = Pick<UniversalOptions, 'dir'> & Pick<Config, 'catalogs' | 'ignoreScripts' | 'rawConfig' | 'embedReadme' | 'packGzipLevel' | 'nodeLinker'> & Partial<Pick<Config, 'extraBinPaths' | 'extraEnv' | 'recursive' | 'selectedProjectsGraph' | 'workspaceConcurrency' | 'workspaceDir'>> & {
    argv: {
        original: string[];
    };
    engineStrict?: boolean;
    packDestination?: string;
    out?: string;
    json?: boolean;
    unicode?: boolean;
};
export interface PackResultJson {
    name: string;
    version: string;
    filename: string;
    files: Array<{
        path: string;
    }>;
}
export declare function handler(opts: PackOptions): Promise<string>;
export declare function api(opts: PackOptions): Promise<PackResult>;
export interface PackResult {
    publishedManifest: ProjectManifest;
    contents: string[];
    tarballPath: string;
}
